#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Crimson
#property indicator_width1 4
#property indicator_width2 4
#property indicator_level1 0
#property indicator_levelcolor Violet



extern string note_TimeFrames   = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string TimeFrame         = "Current time frame";
extern int    SmoothLength      = 5;
extern int    SmoothPhase       = 0;
extern bool   Interpolate       = true;
extern bool   InterpolateColors = true;

extern string _                 = "alerts settings";
extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = true;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;





double Up[];
double Down[];
double ftlm2[];
double trend[];


string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;



int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,Up);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Down); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ftlm2);
   SetIndexBuffer(3,trend);
   
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" jurik Ftlm ");
   
   return(0);
  }


int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);
   if (returnBars) { Up[0] = limit+1; return(0); }
   
   if (calculateValue || timeFrame == Period())
   {
   
   for(i=limit; i>=0; i--)
   {
  double value1 = 
0.4360409450*Close[i+0] 
+0.3658689069*Close[i+1] 
+0.2460452079*Close[i+2] 
+0.1104506886*Close[i+3] 
-0.0054034585*Close[i+4] 
-0.0760367731*Close[i+5] 
-0.0933058722*Close[i+6] 
-0.0670110374*Close[i+7] 
-0.0190795053*Close[i+8] 
+0.0259609206*Close[i+9] 
+0.0502044896*Close[i+10] 
+0.0477818607*Close[i+11] 
+0.0249252327*Close[i+12] 
-0.0047706151*Close[i+13] 
-0.0272432537*Close[i+14] 
-0.0338917071*Close[i+15] 
-0.0244141482*Close[i+16] 
-0.0055774838*Close[i+17] 
+0.0128149838*Close[i+18] 
+0.0226522218*Close[i+19] 
+0.0208778257*Close[i+20] 
+0.0100299086*Close[i+21] 
-0.0036771622*Close[i+22] 
-0.0136744850*Close[i+23] 
-0.0160483392*Close[i+24] 
-0.0108597376*Close[i+25] 
-0.0016060704*Close[i+26] 
+0.0069480557*Close[i+27] 
+0.0110573605*Close[i+28] 
+0.0095711419*Close[i+29] 
+0.0040444064*Close[i+30] 
-0.0023824623*Close[i+31] 
-0.0067093714*Close[i+32] 
-0.0072003400*Close[i+33] 
-0.0047717710*Close[i+34] 
+0.0005541115*Close[i+35] 
+0.0007860160*Close[i+36] 
+0.0130129076*Close[i+37] 
+0.0040364019*Close[i+38]; 

  double value2 = 
-0.0025097319*Close[i+0] 
+0.0513007762*Close[i+1] 
+0.1142800493*Close[i+2] 
+0.1699342860*Close[i+3] 
+0.2025269304*Close[i+4] 
+0.2025269304*Close[i+5] 
+0.1699342860*Close[i+6] 
+0.1142800493*Close[i+7] 
+0.0513007762*Close[i+8] 
-0.0025097319*Close[i+9] 
-0.0353166244*Close[i+10] 
-0.0433375629*Close[i+11] 
-0.0311244617*Close[i+12] 
-0.0088618137*Close[i+13] 
+0.0120580088*Close[i+14] 
+0.0233183633*Close[i+15] 
+0.0221931304*Close[i+16] 
+0.0115769653*Close[i+17] 
-0.0022157966*Close[i+18] 
-0.0126536111*Close[i+19] 
-0.0157416029*Close[i+20] 
-0.0113395830*Close[i+21] 
-0.0025905610*Close[i+22] 
+0.0059521459*Close[i+23] 
+0.0105212252*Close[i+24] 
+0.0096970755*Close[i+25] 
+0.0046585685*Close[i+26] 
-0.0017079230*Close[i+27] 
-0.0063513565*Close[i+28] 
-0.0074539350*Close[i+29] 
-0.0050439973*Close[i+30] 
-0.0007459678*Close[i+31] 
+0.0032271474*Close[i+32] 
+0.0051357867*Close[i+33] 
+0.0044454862*Close[i+34] 
+0.0018784961*Close[i+35] 
-0.0011065767*Close[i+36] 
-0.0031162862*Close[i+37] 
-0.0033443253*Close[i+38] 
-0.0022163335*Close[i+39] 
+0.0002573669*Close[i+40] 
+0.0003650790*Close[i+41] 
+0.0060440751*Close[i+42] 
+0.0018747783*Close[i+43]; 

   double value3 = 
0.4360409450*Close[i+0+1] 
+0.3658689069*Close[i+1+1] 
+0.2460452079*Close[i+2+1] 
+0.1104506886*Close[i+3+1] 
-0.0054034585*Close[i+4+1] 
-0.0760367731*Close[i+5+1] 
-0.0933058722*Close[i+6+1] 
-0.0670110374*Close[i+7+1] 
-0.0190795053*Close[i+8+1] 
+0.0259609206*Close[i+9+1] 
+0.0502044896*Close[i+10+1] 
+0.0477818607*Close[i+11+1] 
+0.0249252327*Close[i+12+1] 
-0.0047706151*Close[i+13+1] 
-0.0272432537*Close[i+14+1] 
-0.0338917071*Close[i+15+1] 
-0.0244141482*Close[i+16+1] 
-0.0055774838*Close[i+17+1] 
+0.0128149838*Close[i+18+1] 
+0.0226522218*Close[i+19+1] 
+0.0208778257*Close[i+20+1] 
+0.0100299086*Close[i+21+1] 
-0.0036771622*Close[i+22+1] 
-0.0136744850*Close[i+23+1] 
-0.0160483392*Close[i+24+1] 
-0.0108597376*Close[i+25+1] 
-0.0016060704*Close[i+26+1] 
+0.0069480557*Close[i+27+1] 
+0.0110573605*Close[i+28+1] 
+0.0095711419*Close[i+29+1] 
+0.0040444064*Close[i+30+1] 
-0.0023824623*Close[i+31+1] 
-0.0067093714*Close[i+32+1] 
-0.0072003400*Close[i+33+1] 
-0.0047717710*Close[i+34+1] 
+0.0005541115*Close[i+35+1] 
+0.0007860160*Close[i+36+1] 
+0.0130129076*Close[i+37+1] 
+0.0040364019*Close[i+38+1]; 

   double value4 = 
-0.0025097319*Close[i+0+1] 
+0.0513007762*Close[i+1+1] 
+0.1142800493*Close[i+2+1] 
+0.1699342860*Close[i+3+1] 
+0.2025269304*Close[i+4+1] 
+0.2025269304*Close[i+5+1] 
+0.1699342860*Close[i+6+1] 
+0.1142800493*Close[i+7+1] 
+0.0513007762*Close[i+8+1] 
-0.0025097319*Close[i+9+1] 
-0.0353166244*Close[i+10+1] 
-0.0433375629*Close[i+11+1] 
-0.0311244617*Close[i+12+1] 
-0.0088618137*Close[i+13+1] 
+0.0120580088*Close[i+14+1] 
+0.0233183633*Close[i+15+1] 
+0.0221931304*Close[i+16+1] 
+0.0115769653*Close[i+17+1] 
-0.0022157966*Close[i+18+1] 
-0.0126536111*Close[i+19+1] 
-0.0157416029*Close[i+20+1] 
-0.0113395830*Close[i+21+1] 
-0.0025905610*Close[i+22+1] 
+0.0059521459*Close[i+23+1] 
+0.0105212252*Close[i+24+1] 
+0.0096970755*Close[i+25+1] 
+0.0046585685*Close[i+26+1] 
-0.0017079230*Close[i+27+1] 
-0.0063513565*Close[i+28+1] 
-0.0074539350*Close[i+29+1] 
-0.0050439973*Close[i+30+1] 
-0.0007459678*Close[i+31+1] 
+0.0032271474*Close[i+32+1] 
+0.0051357867*Close[i+33+1] 
+0.0044454862*Close[i+34+1] 
+0.0018784961*Close[i+35+1] 
-0.0011065767*Close[i+36+1] 
-0.0031162862*Close[i+37+1] 
-0.0033443253*Close[i+38+1] 
-0.0022163335*Close[i+39+1] 
+0.0002573669*Close[i+40+1] 
+0.0003650790*Close[i+41+1] 
+0.0060440751*Close[i+42+1] 
+0.0018747783*Close[i+43+1]; 

double FTLM  = iSmooth(value1-value2,SmoothLength,SmoothPhase,i, 0);
double FTLM1 = iSmooth(value3-value4,SmoothLength,SmoothPhase,i,10);

if (FTLM > FTLM1) 
{
Up[i]=FTLM;
Down[i]=EMPTY_VALUE;
} 
else 
{
Down[i]=FTLM;
Up[i]=EMPTY_VALUE;
}

trend[i] = trend[i+1];
if (Up[i] ==  FTLM && Up[i+1]   == EMPTY_VALUE) trend[i] = 1;
if (Down[i]== FTLM && Down[i+1] == EMPTY_VALUE) trend[i] = -1;
manageAlerts();   
}
    
return(0);
}

//+------------------------------------------------------------------+

limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"","returnBars",4,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
   int y    = iBarShift(NULL,timeFrame,Time[i]);
   Up[i]    = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",SmoothLength,SmoothPhase,0,y);
   Down[i]  = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",SmoothLength,SmoothPhase,1,y);
   ftlm2[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",SmoothLength,SmoothPhase,2,y);
   trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue",SmoothLength,SmoothPhase,3,y);
   
   if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
   if (!Interpolate) continue;
   
   datetime time = iTime(NULL,timeFrame,y);
   for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
   for(int k = 1; k < n; k++)
   {
   ftlm2[i+k]= ftlm2[i]+ (ftlm2[i+n] - ftlm2[i])*k/n;
   
   if (InterpolateColors)
   {
   Up[i+k]   = Up[i]    + (Up[i+n]    - Up[i])*k/n;
   Down[i+k] = Down[i]  + (Down[i+n]  - Down[i])*k/n;
   }
   else
   {
   if (Up[i]   !=0) Up[i+k]   = ftlm2[i+k];
   if (Down[i] !=0) Down[i+k] = ftlm2[i+k];
   }               
   }             
   }
   
   manageAlerts();
   return(0);
}


//+------------------------------------------------------------------+


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}



void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Ftlm trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ftlm "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

    
double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}